using System;
using System.Threading;

namespace PrikladyZive51
{
	/// <summary>
	/// 
	/// </summary>
	internal class NotPulsingExam
	{
		internal static void Run()
		{
			Thread.CurrentThread.Name = "Prvni vlakno";
			Thread lSecond = new Thread(new ThreadStart(DoSomeWork));
			lSecond.Name = "Druhe vlakno";
			lSecond.Start();
			DoSomeWork();
		}
		
		internal static void DoSomeWork()
		{
			//ziskani zamku
			lock(typeof(NotPulsingExam))
			{
				for (int i = 0; i < 3; i++)
				{
					Console.WriteLine("{0} - {1}", Thread.CurrentThread.Name, i);
				}
			}
			//uvolneni zamku
		}
	}
}
