using System;
using System.Threading;

namespace PrikladyZive51
{
	/// <summary>
	/// Ukazkovy priklad na notifikaci vlaken, pomoci metody Pulse
	/// tridy Monitor
	/// </summary>
	internal class PulsingExam
	{

		internal static void Run()
		{
			Thread.CurrentThread.Name = "Prvni vlakno";
			PulsingExam lInstance = new PulsingExam();
			Thread lSecond = new Thread(new ThreadStart( lInstance.DoSomeWork));
			lSecond.Name = "Druhe vlakno";
			lSecond.Start();
			lInstance.DoSomeWork();
		}
		
		internal void DoSomeWork()
		{
			lock(this)
			{
				for(int i = 0; i < 3; i++)
				{
					Console.WriteLine("{0} - {1}", Thread.CurrentThread.Name, i);
					Monitor.Pulse(this);
					//zabraneni blokaci zamku (deadlocku) 
					if (i < 2)
					{
						Monitor.Wait(this);
					}
				}
			}
		}
	}
}
