using System;
using System.Threading;
using System.Collections;

namespace PrikladyZive51
{
	/// <summary>
	/// Ukazka pouziti metody TryEnter tridy Monitor
	/// </summary>
	internal class TryEnterExam
	{
		//kolekce, ke ktere je vlakny pristupovano synchronizovane
		private ArrayList elements;
		
		internal TryEnterExam()
		{
			elements = new ArrayList();
		}

		private bool TryToAddElement(object Element)
		{
			/*otestuje zda je mozne ziskat zamek objektu elements,
			 * pokud ne, bude se vterinu cekat, jestli nedojde k jeho
			 * uvolneni*/
			if (Monitor.TryEnter(elements, 1000))
			{
				//pokud se podari ziskat zamek pridame element
				elements.Add(Element);
				return true;
			}
			else
			{
				return false;
			}
		}
	}
}
